import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.*;
/**
 * Write a description of class Goon here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Goon extends Actor
{
    int health_;
    
    public Goon()
    {
        super();
        health_ = 35;
    }
    
    /**
     * Act - do whatever the Goon wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        // Add your action code here.
        moveAround();
        
        if(findEnemy())
        {
            getCoordinates();
            
            if(canFire())
            {
                shoot();
            }
        }
        
        if(foundRound())
        {
            getShot();
        }
        else if(foundMac())
        {
            getDesintegrated();
        }
        else if(foundMissile())
        {
            takeHeavyDamage();
        }
     
        dead();
    }    
    
    public void moveAround()
    {
        
        int speed = (int)(Math.random()*1)+2;
        int chance = Greenfoot.getRandomNumber(100);
        int coinToss = Greenfoot.getRandomNumber(2);
        World w = getWorld();
        
        move(speed);
        
        if(chance < 5)
        {
            if(coinToss == 1)
            {
                turn(45);
            }
            else if(coinToss == 2)
            {
                turn(-45);
            }
        }
        
        if(getX() == w.getWidth() || getX() == 0)
        {
            if(coinToss == 1)
            {
                turn(45);
            }
            else if(coinToss == 2)
            {
                turn(-45);
            }
        }
        else if(getY() == w.getHeight() || getY() == 0)
        {
            if(coinToss == 1)
            {
                turn(45);
            }
            else if(coinToss == 2)
            {
                turn(-45);
            }
        }
    }
    
    public boolean findEnemy()
    {
        List<Actor> ships = getObjectsInRange(350, ship.class);
        return ships.size()>0;
    }
    
    public boolean canFire()
    {
        int trigger = (int)(Math.random()*100)+1;//the chances of firing
        return trigger <= 10;
    }
    
    public void shoot()
    {
        LaserBoltEnemy round = new LaserBoltEnemy();
        getWorld().addObject(round, getX(), getY());
        round.setRotation(getRotation());
        round.move(64.0);
    }
    
    public void getCoordinates()
    {
       World w = getWorld(); 
       List<ship> ships = w.getObjects(ship.class);
       ListIterator<ship> itr = ships.listIterator();
       if(!itr.hasNext())
       {
           return;
       }
       
       ship enemy = itr.next();
       
       int x = enemy.getX();
       int y = enemy.getY();
       
       turnTowards(x,y);
    }
    
    public boolean foundRound()
    {
        Actor r = getOneIntersectingObject(LaserBoltPlayer.class);
        return r != null;
    }
    
    public boolean foundMac()
    {
        Actor r = getOneIntersectingObject(Mac.class);
        return r != null;
    }
    
    public boolean foundMissile()
    {
        Actor shell = getOneIntersectingObject(Missile2.class);
        return shell != null;
    }
    
    public void getShot()
    {
        Actor r = getOneIntersectingObject(LaserBoltPlayer.class);
        World w = getWorld();
        w.removeObject(r);
        --health_;
    }
    
    public void getDesintegrated()
    {
        Actor r = getOneIntersectingObject(Mac.class);
        World w = getWorld();
        w.removeObject(r);
        health_ -= 10;
    }
    
    public void takeHeavyDamage()
    {
        Actor shell = getOneIntersectingObject(Missile2.class);
        World w = getWorld();
        w.removeObject(shell);
        health_ -= 20;
    }
    
    public int getHealth()
    {
        return health_;
    }
    
    public void dead()
    {
        if(getHealth() <= 0)
        {
            World w = getWorld();
            w.removeObject(this);
        }
    }
    
}
