import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.*;
/**
 * Write a description of class Redbaron here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Redbaron extends Actor
{
    private int distance = (int)(Math.random()*5)+1;
    private int health_;
    
    public Redbaron()
    {
        super();
        health_ = 1500;
    }
    
    /**
     * Act - do whatever the Redbaron wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        // Add your action code here.
       
        findEnemy();
       
        
        if(canFire())
        {
            shoot();
        }
        else if(canDrop())
        {
            bombHim();
        }
        
        if(foundRound())
        {
           gotHit();
        }
        else if(foundMac())
        {
            getDesintegrated();
        }
        else if(foundMissile())
        {
            takeHighDamage();
        }
        
        dead();
    }    
    
    public boolean canDrop()
    {
        int trigger = (int)(Math.random()*100)+1;
        return trigger <= 2;
    }
    
    public boolean canFire()
    {
        int trigger = (int)(Math.random()*100)+1;//the chances of firing
        return trigger <= 10;
    }
    
    public void dropBombs()
    {
        missile bomb = new missile();
        World w = getWorld();
        int x = getX();
        int y = getY() + getImage().getHeight()/2 + bomb.getImage().getHeight()/2 +5;
        w.addObject(bomb, x, y);
    }
    
    public void shoot()
    {
        LaserBoltEnemy round = new LaserBoltEnemy();
        getWorld().addObject(round, getX(), getY());
        round.setRotation(getRotation());
        round.move(88.0);
    }
  
   //NOTE*****If ship remains immobile, it will move towards ship and glitch. 
  
    public void findEnemy()
    {
       World w = getWorld(); 
       List<ship> ships = w.getObjects(ship.class);
       ListIterator<ship> itr = ships.listIterator();
       if(!itr.hasNext())
       {
           return;
       }
       
       ship enemy = itr.next();
       
       int x = enemy.getX();
       int y = enemy.getY();
       int rx = getX();
       int ry = getY();
       int angle = getRotation();
       move(1);
       turnTowards(x,y);
       }
      
    
    public void bombHim()
    {
       World w = getWorld(); 
       List<ship> ships = w.getObjects(ship.class);
       ListIterator<ship> itr = ships.listIterator();
       if(!itr.hasNext())
       {
           return;
       }
        
       ship enemy = itr.next();
       
       int x = enemy.getX();
       int y = enemy.getY();
       int rx = getX();
       int ry = getY();
       
       if(y > ry)
       {
           dropBombs();
       }
    }
    
    public void deadEnemy()
    {
       World w = getWorld(); 
       List<ship> ships = w.getObjects(ship.class);
       ListIterator<ship> itr = ships.listIterator();
       if(!itr.hasNext())
       {
           return;
       }
           
       ship enemy = itr.next();
       
       int eh = enemy.getHealth();
       
       if(eh <= 0)
       {
           w.removeObject(enemy);
       }
    }
    
    public boolean foundRound()
    {
        Actor r = getOneIntersectingObject(LaserBoltPlayer.class);
        return r != null;
    }
    
    public boolean foundMac()
    {
        Actor r = getOneIntersectingObject(Mac.class);
        return r != null;
    }
    
    public boolean foundMissile()
    {
        Actor m = getOneIntersectingObject(Missile2.class);
        return m != null;
    }
    
    public void gotHit()
    {
        Actor r = getOneIntersectingObject(LaserBoltPlayer.class);
        World w = getWorld();
        w.removeObject(r);
        --health_;
    }
    
    public void getDesintegrated()
    {
        Actor r = getOneIntersectingObject(Mac.class);
        World w = getWorld();
        w.removeObject(r);
        health_ -= 10;
    }
   
    public void takeHighDamage()
    {
        Actor m = getOneIntersectingObject(Missile2.class);
        World w = getWorld();
        w.removeObject(m);
        health_ -= 5;
    }
    
    public int getHealth()
    {
        return health_;
    }
    
    public void dead()
    {
        if(getHealth() <= 0)
        {
            World w = getWorld();
            w.removeObject(this);
        }
    }
}
