import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.*;
/**
 * Write a description of class Runner here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Runner extends Actor
{
    private int health_;
    
    public Runner()
    {
        super();
        health_ = 5;
    }
    /**
     * Act - do whatever the Runner wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        // Add your action code here.
        int distance = 5;
        World w = getWorld();
            
        if(canMove(distance))
        {
            move(distance);
        }
        else
        {
            w.removeObject(this);
            return;
        }
                
        if(atEdge())
        {
            w.removeObject(this);
            return;
        }
        
        if(canDrop())
        {
            bombHim();
            dropBombs();
        }
        
        if(foundRound())
        {
            getShot();
        }
        else if(foundMissile())
        {
            takeHeavyDamage();
        }
        else if(foundMac())
        {
            getDesintegrated();
        }
        
        dead();
    }    
    
    public boolean canMove(int distance)
    {
        
        int y = getY();
        int x = getX();
        World w = getWorld();
        int width = w.getWidth();
        int height = w.getHeight();
        
        return x + distance < width && y + distance < height;
    }
   
    public boolean atEdge()
    {
        World w = getWorld();
        int worldX = w.getWidth();
        int worldY = w.getHeight();
        int x = getX();
        int y = getY();
        if(x <= 1 || x >= worldX-1 || y <= 1 || y >= worldY-1)
        {
            return true;
        }
        else
        {
            return false;
        }
    }
    
    public void dropBombs()
    {
        missile bomb = new missile();
        World w = getWorld();
        int x = getX();
        int y = getY() + getImage().getHeight()/2 + bomb.getImage().getHeight()/2 +5;
        w.addObject(bomb, x, y);
    }
    
    public void bombHim()
    {
       World w = getWorld(); 
       List<ship> ships = w.getObjects(ship.class);
       ListIterator<ship> itr = ships.listIterator();
       if(!itr.hasNext())
       {
           return;
       }
        
       ship enemy = itr.next();

       int y = enemy.getY();
       int rx = getX();
       int ry = getY();
       
       if(y > ry)
       {
           dropBombs();
       }
    }
    
    public boolean canDrop()
    {
        int trigger = (int)(Math.random()*100)+1;
        return trigger <= 2;
    }
    
    public boolean foundRound()
    {
        Actor r = getOneIntersectingObject(LaserBoltPlayer.class);
        return r != null;
    }
    
    public void getShot()
    {
        Actor r = getOneIntersectingObject(LaserBoltPlayer.class);
        getWorld().removeObject(r);
        --health_;
    }
    
    public boolean foundMissile()
    {
        Actor m = getOneIntersectingObject(Missile2.class);
        return m != null;
    }
    
    public void takeHeavyDamage()
    {
        Actor m = getOneIntersectingObject(Missile2.class);
        getWorld().removeObject(m);
        health_ -= 5;
    }
    
    public boolean foundMac()
    {
        Actor r = getOneIntersectingObject(Mac.class);
        return r != null;
    }
    
    
    public void getDesintegrated()
    {
        Actor r = getOneIntersectingObject(Mac.class);
        World w = getWorld();
        w.removeObject(r);
        health_ -= 10;
    }
    
    public int getHealth()
    {
        return health_;
    }
    
    public void dead()
    {
        if(getHealth() <= 0)
        {
            World w = getWorld();
            w.removeObject(this);
        }
    }
}
