import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.*;
/**
 * A space ship equipped for battle!
 * known as the kotsuno.
 * 
 * @author (ﾆメシュ) 
 * @version (21/04/013)
 */
public class ship extends Actor
{   
    private final int change = 5;
    private int health_;
    private int count_;
    private int canShoot_;
    public ship()
    {
        super();
        health_ = 100;
        canShoot_ = 100;
        count_ = canShoot_;
    }
    
    /**
     * Act - do whatever the ship wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        // Add your action code here.
        nextX();
        nextY();
        
        turret(); 
        missileLauncher();
        tracer();
       
        if(foundRound())
        {
            getShot();
        }
        else if(foundBomb())
        {
            getBombed();
        }
        
        if(getHealth() <= 0)
        {
            World w = getWorld();
            w.removeObject(this);
            return;
        }
        
        if(Greenfoot.isKeyDown("o") && count_ >= canShoot_)
        {
            fireMac();
        }
        
        if(findHealthPack())
        {
            heal();
        }
      
        count_ ++;
    }    
    
    public void nextX()
    {
        if(Greenfoot.isKeyDown("a"))
        {
            turn(-3);
            setRotation(getRotation());
        }
        else if(Greenfoot.isKeyDown("d"))
        {
            turn(3);
            setRotation(getRotation());
        }
    }
    
    public void nextY()
    {
        if(Greenfoot.isKeyDown("w"))
        {
            move(5);
        }
    }
    
    public boolean foundRound()
    {
        Actor r = getOneIntersectingObject(LaserBoltEnemy.class);
        return r != null;
    }
    
    public void getShot()
    {
        Actor r = getOneIntersectingObject(LaserBoltEnemy.class);
        World w = getWorld();
        w.removeObject(r);
        health_ --;
    }
        
    public boolean foundBomb()
    {
        Actor b = getOneIntersectingObject(missile.class);
        return b != null;
    }
    
    public void getBombed()
    {
        Actor b = getOneIntersectingObject(missile.class);
        World w = getWorld();
        w.removeObject(b);
        health_ -= 10;
    }
    
    public int getHealth()
    {
        return health_;
    }
      
   public void turret()
   {
       //NOTE : THIS ONE IS turreta2!
       TurretA t = new TurretA();
       World w = getWorld();
       t.setRotation(getRotation());
       
       double dx = 41;
       double dy = -12;
       double d = Math.sqrt(dx*dx + dy*dy);
       double angle = Math.toRadians(getRotation());
       double offset = Math.atan(dy/dx);
       int newX = (int)Math.round(getX() + d*Math.cos(angle-offset));
       int newY = (int)Math.round(getY() + d*Math.sin(angle-offset));
       w.addObject(t,newX,newY);
       
        //NOTE: THIS ONE IS turreta!
        
        TurretA t2 = new TurretA();
        t2.setRotation(getRotation());
        
        double ix = 41;
        double ay = 12;
        double c = Math.sqrt(ix*ix + ay*ay);
        double angle2 = Math.toRadians(getRotation());
        double offset2 = Math.atan(ay/ix);
        int newX2 = (int)Math.round(getX() + c*Math.cos(angle2-offset2));
        int newY2 = (int)Math.round(getY() + c*Math.sin(angle2-offset2));
        w.addObject(t2,newX2,newY2);
    }

    public void fireMac()
    {
        Mac round = new Mac();
        getWorld().addObject(round, getX(), getY());
        round.setRotation(getRotation());
        round.move(60.0);
        count_ = 0;
    }
    
    public void missileLauncher()
    {
        World w = getWorld();
        Lancher missile = new Lancher();
        w.addObject(missile, getX(), getY());
        missile.setRotation(getRotation());
        missile.move(40.0);
        
        if(getHealth() <= 0)
        {
            w.removeObject(missile);
        }
        
        if(Greenfoot.isKeyDown("j") && count_ >= canShoot_)
        {
            missile.fire();
            count_ = 0;
        }
    }
    
    public void tracer()
    {
        World w = getWorld();
        //top turret
        TurretT t = new TurretT();
        t.setRotation(getRotation()-90);
        
        double dx = -17;
        double dy = -23;
        double d = Math.sqrt(dx*dx + dy*dy);
        double angle = Math.toRadians(getRotation());
        double offset = Math.atan(dy/dx);
        int newX = (int)Math.round(getX() + d*Math.cos(angle-offset));
        int newY = (int)Math.round(getY() + d*Math.sin(angle-offset));
        w.addObject(t,newX,newY);
        
        //bottom turret
        TurretT t2 = new TurretT();
        t2.setRotation(getRotation()+90);
        
        double ix = -17;
        double ay = 23;
        double c = Math.sqrt(ix*ix + ay*ay);
        double angle2 = Math.toRadians(getRotation());
        double offset2 = Math.atan(ay/ix);
        int newX2 = (int)Math.round(getX() + c*Math.cos(angle2-offset2));
        int newY2 = (int)Math.round(getY() + c*Math.sin(angle2-offset2));
        w.addObject(t2,newX2,newY2);
        
        if(getHealth() <= 0)
        {
            w.removeObject(t);
        }
        
        if(Greenfoot.isKeyDown("u"))
        {
            t.fire();
        }
        else if(Greenfoot.isKeyDown("i"))
        {
            t2.fire();
        }
        
    }
    
    public boolean findHealthPack()
    {
        Actor healthPack = getOneIntersectingObject(RepairPack.class);
        return healthPack != null; 
    }
    
    public void heal()
    {
        Actor healthPack = getOneIntersectingObject(RepairPack.class);
        World w = getWorld();
        w.removeObject(healthPack);
        health_ += 10;
    }
    
}
